!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   fhn :        The FitzHugh - Nagumo Equation
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION rI, a, b, c, v, w

       rI=PAR(1)
       a =PAR(2)
       b =PAR(3)
       c =PAR(4)

       v=U(1)
       w=U(2)

       F(1)= v - v**3/3 - w  + rI
       F(2)= a*(v + b - c*w)

      END SUBROUTINE FUNC
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION rI, a, b, c

! Initialize the equation parameters
       rI = 0.
       a  = 0.08
       b  = 0.7
       c  = 0.8

       PAR(1) = rI
       PAR(2) = a
       PAR(3) = b
       PAR(4) = c

! Initialize the solution (assuming PAR(1)=0 )
       U(1)=-1.19941D+00 
       U(2)=-6.24260D-01

      END SUBROUTINE STPNT
!----------------------------------------------------------------------
!----------------------------------------------------------------------
      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS
!----------------------------------------------------------------------
!----------------------------------------------------------------------
